/* Problem URL: https://codeforces.com/gym/103960/problem/F */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, c;
    cin >> n >> c;

    vvi trie(1, vi(26));
    vvi count(1, vi(26));
    
    function<int(string&, int, int)> add = [&](string &a, int i, int p) {
        if (a[i] == '*') {
            int maximal = 0;
            rep(j, 26) {
                if (trie[p][j] == 0) {
                    trie[p][j] = trie.size();
                    trie.emplace_back(26);
                    count.emplace_back(26);
                }

                if (i == c - 1) {
                    count[p][j]++;
                    rmax(maximal, count[p][j]);
                    continue;
                }

                rmax(count[p][j], add(a, i + 1, trie[p][j]));
                rmax(maximal, count[p][j]);
            }

            return maximal;
        }

        if (trie[p][a[i] - 'a'] == 0) {
            trie[p][a[i] - 'a'] = trie.size();
            trie.emplace_back(26);
            count.emplace_back(26);
        }

        if (i == c - 1) {
            count[p][a[i] - 'a']++;
            return count[p][a[i] - 'a'];
        }

        rmax(count[p][a[i] - 'a'], add(a, i + 1, trie[p][a[i] - 'a']));

        return count[p][a[i] - 'a'];
    };

    while (n--) {
        string f;
        cin >> f;

        add(f, 0, 0);
    }

    string ans;
    int now = 0;
    int ansc = 0;

    rep(i, c) {
        int tmp = 0;
        int maximal = 0;

        rep(j, 26) {
            if (count[now][j] > maximal) {
                maximal = count[now][j];
                tmp = j;
            }
        }

        ans.push_back(tmp + 'a');
        ansc = maximal;
        now = trie[now][tmp];
    }

    cout << ans << ' ' << ansc << '\n';
}
